#
# Conditional build:
%bcond_without	java		# JNI interface [builds with java-sun 1.6, but not gcj 4.9]
%bcond_without	python		# Python agent
%bcond_without	systemtap	# SystemTap integration
%bcond_without	static_libs	# static libraries
#
Summary:	LTTng Userspace Tracer
Summary(pl.UTF-8):	LTTng Userspace Tracer - narzędzia LTTng do śledzenia przestrzeni użytkownika
Name:		lttng-ust
Version:	2.13.9
Release:	1
License:	LGPL v2.1 (library), MIT (headers), GPL v2 (programs)
Group:		Libraries
Source0:	https://lttng.org/files/lttng-ust/%{name}-%{version}.tar.bz2
# Source0-md5:	ab3bc006eb182bccd94aa0ead99c7201
Patch0:		%{name}-link.patch
Patch2:		%{name}-python.patch
URL:		https://lttng.org/
BuildRequires:	autoconf >= 2.69
BuildRequires:	automake >= 1:1.12
# for examples build
BuildRequires:	cmake >= 2.8.11
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	libtool >= 2:2
BuildRequires:	numactl-devel
BuildRequires:	pkgconfig
%{?with_python:BuildRequires:	python >= 1:2.7}
%{?with_python:BuildRequires:	python-modules >= 1:2.7}
BuildRequires:	rpmbuild(macros) >= 1.294
BuildRequires:	sed >= 4.0
%{?with_systemtap:BuildRequires:	systemtap-sdt-devel}
BuildRequires:	userspace-rcu-devel >= 0.13
%if %{with java}
BuildRequires:	java-log4j
BuildRequires:	jdk
BuildRequires:	jpackage-utils
%endif
Requires:	userspace-rcu >= 0.13
ExclusiveArch:	%{ix86} %{x8664} x32 %{arm} aarch64 mips ppc ppc64 s390 s390x tile
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# non-function rcu_reader_bp symbol
%define		skip_post_check_so_1	liblttng-ust\.so.* liblttng-ust-cyg-profile\.so.* liblttng-ust-cyg-profile-fast\.so.* liblttng-ust-dl\.so.* liblttng-ust-java\.so.* liblttng-ust-python-agent\.so.* liblttng-ust-tracepoint\.so.*
# non-function lttng_ust_context_info_tls symbol
%define		skip_post_check_so_2	liblttng-ust-jul-jni\.so.* liblttng-ust-log4j-jni\.so.*
# lttng_ust_sigbus_state symbol must be defined in executable
%define		skip_post_check_so_3	liblttng-ust-ctl\.so.*

%define		skip_post_check_so	%{skip_post_check_so_1} %{skip_post_check_so_2} %{skip_post_check_so_3}

%description
The LTTng Userspace Tracer (UST) is a library accompanied by a set of
tools to trace userspace code. 

%description -l pl.UTF-8
LTTng Userspace Tracer (UST) to biblioteka, której towarzyszą
narzędzia do śledzenia kodu w przestrzeni użytkownika.

%package devel
Summary:	Header files for LTTNG-UST libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek LTTNG-UST
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	userspace-rcu-devel >= 0.13
%{?with_systemtap:Requires:	systemtap-sdt-devel}

%description devel
Header files for LTTNG-UST libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek LTTNG-UST.

%package static
Summary:	Static LTTNG-UST libraries
Summary(pl.UTF-8):	Statyczne biblioteki LTTNG-UST
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static LTTNG-UST libraries.

%description static -l pl.UTF-8
Statyczne biblioteki LTTNG-UST.

%package -n java-lttng-ust
Summary:	JNI interface for LTTng Userspace Tracer library
Summary(pl.UTF-8):	Interfejs JNI do biblioteki LTTng Userspace Tracer
Group:		Libraries/Java
Requires:	%{name} = %{version}-%{release}

%description -n java-lttng-ust
JNI interface for LTTng Userspace Tracer library.

%description -n java-lttng-ust -l pl.UTF-8
Interfejs JNI do biblioteki LTTng Userspace Tracer.

%package -n python-lttng-ust
Summary:	Python agent for LTTng Userspace Tracer library
Summary(pl.UTF-8):	Agent Pythona do biblioteki LTTng Userspace Tracer
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}

%description -n python-lttng-ust
Python agent for LTTng Userspace Tracer library.

%description -n python-lttng-ust -l pl.UTF-8
Agent Pythona do biblioteki LTTng Userspace Tracer.

%prep
%setup -q
%patch -P0 -p1
%patch -P2 -p1

%{__sed} -i -e '1s,/usr/bin/env python$,%{__python},' tools/lttng-gen-tp

%build
%{__libtoolize}
%{__aclocal} -I config
%{__autoconf}
%{__autoheader}
%{__automake}
export CLASSPATH=.:%{_javadir}/log4j.jar
%configure \
	PYTHON=%{__python} \
	%{?with_java:JAVA_HOME="%{java_home}" JAVAC=javac} \
	--disable-silent-rules \
	%{?with_java:--enable-jni-interface --enable-java-agent-all} \
	%{?with_python:--enable-python-agent} \
	%{?with_systemtap:--with-sdt} \
	%{?with_static_libs:--enable-static}

%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	lttnglibjavadir=%{_javadir}

# *.la kept - no .pc files for individual libraries

install -d $RPM_BUILD_ROOT%{_examplesdir}
%{__mv} $RPM_BUILD_ROOT%{_docdir}/lttng-ust/examples $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
# packaged as %doc
%{__rm} $RPM_BUILD_ROOT%{_docdir}/lttng-ust/{ChangeLog,README.md,java-agent.txt}

%if %{with java}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/liblttng-ust-{context-jni,java,jul-jni,log4j-jni}.la \
	%{?with_static_libs:$RPM_BUILD_ROOT%{_libdir}/liblttng-ust-{context-jni,java,jul-jni,log4j-jni}.a}
%endif
%if %{with python}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/liblttng-ust-python-agent.la \
	%{?with_static_libs:$RPM_BUILD_ROOT%{_libdir}/liblttng-ust-python-agent.a}
%py_postclean
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n java-lttng-ust -p /sbin/ldconfig
%postun	-n java-lttng-ust -p /sbin/ldconfig

%post	-n python-lttng-ust -p /sbin/ldconfig
%postun	-n python-lttng-ust -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc ChangeLog LICENSE README.md
%attr(755,root,root) %{_libdir}/liblttng-ust.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-common.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-common.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-ctl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-ctl.so.5
%attr(755,root,root) %{_libdir}/liblttng-ust-cyg-profile.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-cyg-profile.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-cyg-profile-fast.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-cyg-profile-fast.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-dl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-dl.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-fd.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-fd.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-fork.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-fork.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-libc-wrapper.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-libc-wrapper.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-pthread-wrapper.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-pthread-wrapper.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-tracepoint.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-tracepoint.so.1

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/lttng-gen-tp
%attr(755,root,root) %{_libdir}/liblttng-ust.so
%attr(755,root,root) %{_libdir}/liblttng-ust-common.so
%attr(755,root,root) %{_libdir}/liblttng-ust-ctl.so
%attr(755,root,root) %{_libdir}/liblttng-ust-cyg-profile.so
%attr(755,root,root) %{_libdir}/liblttng-ust-cyg-profile-fast.so
%attr(755,root,root) %{_libdir}/liblttng-ust-dl.so
%attr(755,root,root) %{_libdir}/liblttng-ust-fd.so
%attr(755,root,root) %{_libdir}/liblttng-ust-fork.so
%attr(755,root,root) %{_libdir}/liblttng-ust-libc-wrapper.so
%attr(755,root,root) %{_libdir}/liblttng-ust-pthread-wrapper.so
%attr(755,root,root) %{_libdir}/liblttng-ust-tracepoint.so
%{_libdir}/liblttng-ust.la
%{_libdir}/liblttng-ust-common.la
%{_libdir}/liblttng-ust-ctl.la
%{_libdir}/liblttng-ust-cyg-profile.la
%{_libdir}/liblttng-ust-cyg-profile-fast.la
%{_libdir}/liblttng-ust-dl.la
%{_libdir}/liblttng-ust-fd.la
%{_libdir}/liblttng-ust-fork.la
%{_libdir}/liblttng-ust-libc-wrapper.la
%{_libdir}/liblttng-ust-pthread-wrapper.la
%{_libdir}/liblttng-ust-tracepoint.la
%{_includedir}/lttng
%{_pkgconfigdir}/lttng-ust.pc
%{_pkgconfigdir}/lttng-ust-ctl.pc
%{_mandir}/man1/lttng-gen-tp.1*
%{_mandir}/man3/do_tracepoint.3*
%{_mandir}/man3/lttng-ust.3*
%{_mandir}/man3/lttng-ust-cyg-profile.3*
%{_mandir}/man3/lttng-ust-dl.3*
%{_mandir}/man3/lttng_ust_*.3*
%{_mandir}/man3/tracef.3*
%{_mandir}/man3/tracelog.3*
%{_mandir}/man3/tracepoint.3*
%{_mandir}/man3/tracepoint_enabled.3*
%{_examplesdir}/%{name}-%{version}

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/liblttng-ust.a
%{_libdir}/liblttng-ust-common.a
%{_libdir}/liblttng-ust-ctl.a
%{_libdir}/liblttng-ust-cyg-profile.a
%{_libdir}/liblttng-ust-cyg-profile-fast.a
%{_libdir}/liblttng-ust-dl.a
%{_libdir}/liblttng-ust-fd.a
%{_libdir}/liblttng-ust-fork.a
%{_libdir}/liblttng-ust-libc-wrapper.a
%{_libdir}/liblttng-ust-pthread-wrapper.a
%{_libdir}/liblttng-ust-tracepoint.a
%endif

%if %{with java}
%files -n java-lttng-ust
%defattr(644,root,root,755)
%doc doc/java-agent.txt
%attr(755,root,root) %{_libdir}/liblttng-ust-context-jni.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-context-jni.so.0
%attr(755,root,root) %{_libdir}/liblttng-ust-context-jni.so
%attr(755,root,root) %{_libdir}/liblttng-ust-java.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-java.so.0
%attr(755,root,root) %{_libdir}/liblttng-ust-java.so
%attr(755,root,root) %{_libdir}/liblttng-ust-jul-jni.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-jul-jni.so.0
%attr(755,root,root) %{_libdir}/liblttng-ust-jul-jni.so
%attr(755,root,root) %{_libdir}/liblttng-ust-log4j-jni.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-log4j-jni.so.0
%attr(755,root,root) %{_libdir}/liblttng-ust-log4j-jni.so
%{_javadir}/liblttng-ust-agent.jar
%{_javadir}/liblttng-ust-java.jar
%{_javadir}/lttng-ust-agent-all-1.0.0.jar
%{_javadir}/lttng-ust-agent-all.jar
%{_javadir}/lttng-ust-agent-common-1.0.0.jar
%{_javadir}/lttng-ust-agent-common.jar
%{_javadir}/lttng-ust-agent-jul-1.0.0.jar
%{_javadir}/lttng-ust-agent-jul.jar
%{_javadir}/lttng-ust-agent-log4j-1.0.0.jar
%{_javadir}/lttng-ust-agent-log4j.jar
%endif

%if %{with python}
%files -n python-lttng-ust
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblttng-ust-python-agent.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblttng-ust-python-agent.so.1
%attr(755,root,root) %{_libdir}/liblttng-ust-python-agent.so
%{py_sitescriptdir}/lttngust
%{py_sitescriptdir}/lttngust-%{version}-py*.egg-info
%endif
%changelog
* Wed Apr 16 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lttng-ust.git;a=log;h=master

* Wed Apr 16 2025 Jakub Bogusz <qboosh@pld-linux.org> d7ec944
- updated to 2.13.9

* Wed Apr 16 2025 Jakub Bogusz <qboosh@pld-linux.org> 3dfe376
- use patch -P

* Sun Apr 21 2024 Jakub Bogusz <qboosh@pld-linux.org> c8cb785
- updated to 2.13.8

* Mon Mar 04 2024 Jakub Bogusz <qboosh@pld-linux.org> aa7ee9c
- updated to 2.13.7

* Sat Jul 22 2023 Jakub Bogusz <qboosh@pld-linux.org> 50cd927
- updated to 2.13.6

* Sat Mar 18 2023 Jan Palus <atler@pld-linux.org> aefdde4
- BR: python-modules

* Fri Mar 17 2023 Jakub Bogusz <qboosh@pld-linux.org> 90a30ae
- updated to 2.13.5

* Sun May 08 2022 Jakub Bogusz <qboosh@pld-linux.org> 365a07b
- updated to 2.13.2

* Sat Feb 05 2022 Jakub Bogusz <qboosh@pld-linux.org> ec86b2a
- updated to 2.13.1 (new sonames)
- updated link,java,python patches

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 1600c78
- rebuild with separate debuginfo build-ids

* Fri Feb 26 2021 Jakub Bogusz <qboosh@pld-linux.org> ef21f53
- release 2

* Fri Feb 26 2021 Jakub Bogusz <qboosh@pld-linux.org> 13ee362
- rediffed/updated patches

* Fri Feb 26 2021 Jakub Bogusz <qboosh@pld-linux.org> 31eefca
- updated to 2.12.1

* Mon Apr 13 2020 Jakub Bogusz <qboosh@pld-linux.org> 41f57d1
- updated to 2.12.0

* Sun Dec 01 2019 Jakub Bogusz <qboosh@pld-linux.org> 5810b81
- updated to 2.11.0

* Sat Oct 26 2019 Jakub Bogusz <qboosh@pld-linux.org> 3cd9838
- updated to 2.10.6

* Wed Jul 17 2019 Jakub Bogusz <qboosh@pld-linux.org> eee883f
- updated to 2.10.4

* Fri Mar 29 2019 Jakub Bogusz <qboosh@pld-linux.org> aa4fbb6
- updated to 2.10.3

* Sat Oct 13 2018 Jakub Bogusz <qboosh@pld-linux.org> e86d12e
- updated to 2.10.2
- updated link patch

* Sat Dec 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 140582f
- updated to 2.10.1 (note: new liblttng-ust-ctl soname)

